﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.DesktopEdition;

namespace mapaneiva
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            winformsMap1.MapUnit = GeographyUnit.DecimalDegree;
            winformsMap1.BackgroundOverlay.BackgroundBrush = new GeoSolidBrush(GeoColor.FromArgb(255, 233, 232, 214));

            //layers for the watercourses
            ShapeFileFeatureLayer riosNeiva1 = new ShapeFileFeatureLayer(@"..\..\Data\MapasNeiva\RiosYCanales\COB_CANAL_DOBLE_SHP_line.shp");
            riosNeiva1.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            riosNeiva1.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.Water1;

            ShapeFileFeatureLayer riosNeiva2 = new ShapeFileFeatureLayer(@"..\..\Data\MapasNeiva\RiosYCanales\COB_DRENAJE_DOBLE_SHP_line.shp");
            riosNeiva2.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            riosNeiva2.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.Water1;

            ShapeFileFeatureLayer riosNeiva3 = new ShapeFileFeatureLayer(@"..\..\Data\MapasNeiva\RiosYCanales\COB_DRENAJE_SENCILLO_SHP_line.shp");
            riosNeiva3.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            riosNeiva3.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.Water1;

            ShapeFileFeatureLayer riosNeiva4 = new ShapeFileFeatureLayer(@"..\..\Data\MapasNeiva\RiosYCanales\COB_LAGUNA_SHP_line.shp");
            riosNeiva4.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            riosNeiva4.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.Water1;

            //layers for the roads and railroads
            ShapeFileFeatureLayer viasNeiva = new ShapeFileFeatureLayer(@"..\..\Data\MapasNeiva\TrazadoComunas1_6\COB_CAPA_VIAL_SHP_line.shp");
            viasNeiva.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            viasNeiva.ZoomLevelSet.ZoomLevel01.CustomStyles.Add(LineStyles.LocalRoad1);

            ShapeFileFeatureLayer ferrocarrilNeiva = new ShapeFileFeatureLayer(@"..\..\Data\MapasNeiva\TrazadoComunas1_6\COB_VIA_FERREA_SHP_line.shp");
            ferrocarrilNeiva.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            ferrocarrilNeiva.ZoomLevelSet.ZoomLevel01.CustomStyles.Add(LineStyles.Railway1);

            //layers for the city outline
            ShapeFileFeatureLayer mapaNeiva1 = new ShapeFileFeatureLayer(@"..\..\Data\MapasNeiva\TrazadoComunas1_6\0_line.shp");
            mapaNeiva1.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            mapaNeiva1.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle=AreaStyles.Urban1;

            ShapeFileFeatureLayer mapaNeiva2 = new ShapeFileFeatureLayer(@"..\..\Data\MapasNeiva\TrazadoComunas1_6\0_polygon.shp");
            mapaNeiva2.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            mapaNeiva2.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.Urban1;

            ShapeFileFeatureLayer mapaNeiva3 = new ShapeFileFeatureLayer(@"..\..\Data\MapasNeiva\TrazadoComunas1_6\55_line.shp");
            mapaNeiva3.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            mapaNeiva3.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.Urban1;

            ShapeFileFeatureLayer mapaNeiva4 = new ShapeFileFeatureLayer(@"..\..\Data\MapasNeiva\TrazadoComunas1_6\55_polygon.shp");
            mapaNeiva4.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            mapaNeiva4.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.Urban1;

            ShapeFileFeatureLayer mapaNeiva5 = new ShapeFileFeatureLayer(@"..\..\Data\MapasNeiva\TrazadoComunas1_6\88_line.shp");
            mapaNeiva5.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            mapaNeiva5.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.Urban1;

            ShapeFileFeatureLayer mapaNeiva6 = new ShapeFileFeatureLayer(@"..\..\Data\MapasNeiva\TrazadoComunas1_6\88_polygon.shp");
            mapaNeiva6.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            mapaNeiva6.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.Urban1;

            ShapeFileFeatureLayer mapaNeiva7 = new ShapeFileFeatureLayer(@"..\..\Data\MapasNeiva\TrazadoComunas1_6\ACH_polygon.shp");
            mapaNeiva7.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            mapaNeiva7.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.Urban1;

            ShapeFileFeatureLayer mapaNeiva8 = new ShapeFileFeatureLayer(@"..\..\Data\MapasNeiva\TrazadoComunas1_6\COB_LINEAS_MZ_SHP_line.shp");
            mapaNeiva8.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            mapaNeiva8.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.Urban1;

            ShapeFileFeatureLayer mapaNeiva9 = new ShapeFileFeatureLayer(@"..\..\Data\MapasNeiva\TrazadoComunas1_6\COB_LOTES_SHP_line.shp");
            mapaNeiva9.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            mapaNeiva9.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.Urban1;

            ShapeFileFeatureLayer mapaNeiva10 = new ShapeFileFeatureLayer(@"..\..\Data\MapasNeiva\TrazadoComunas1_6\COB_LOTES_SHP_polygon.shp");
            mapaNeiva10.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            mapaNeiva10.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.Urban1;

            ShapeFileFeatureLayer mapaNeiva11 = new ShapeFileFeatureLayer(@"..\..\Data\MapasNeiva\TrazadoComunas1_6\COB_MANZANAS_SHP_line.shp");
            mapaNeiva11.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            mapaNeiva11.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.Urban1;

            ShapeFileFeatureLayer mapaNeiva12 = new ShapeFileFeatureLayer(@"..\..\Data\MapasNeiva\TrazadoComunas1_6\COB_PUENTES_SHP_line.shp");
            mapaNeiva12.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            mapaNeiva12.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.Urban1;

            ShapeFileFeatureLayer mapaNeiva13 = new ShapeFileFeatureLayer(@"..\..\Data\MapasNeiva\TrazadoComunas1_6\LOTE_line.shp");
            mapaNeiva13.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            mapaNeiva13.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.Urban1;

            ShapeFileFeatureLayer mapaNeiva14 = new ShapeFileFeatureLayer(@"..\..\Data\MapasNeiva\TrazadoComunas1_6\loteo_line.shp");
            mapaNeiva14.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            mapaNeiva14.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.Urban1;

            //LayerOverlay for the watercourses
            LayerOverlay cuerposAcuaticos = new LayerOverlay();
            cuerposAcuaticos.Layers.Add("CuerposAcuaticos1", riosNeiva1);
            cuerposAcuaticos.Layers.Add("CuerposAcuaticos2", riosNeiva2);
            cuerposAcuaticos.Layers.Add("CuerposAcuaticos3", riosNeiva3);
            cuerposAcuaticos.Layers.Add("CuerposAcuaticos4", riosNeiva4);
            
            //LayerOverlay for the roads and railroads
            LayerOverlay vias =new LayerOverlay();
            vias.Layers.Add("ViasNeiva", viasNeiva);
            vias.Layers.Add("Ferrocarril", ferrocarrilNeiva);

            //LayerOverlay for the city outline
            LayerOverlay neiva = new LayerOverlay();
            neiva.Layers.Add(mapaNeiva1);
            neiva.Layers.Add(mapaNeiva2);
            neiva.Layers.Add(mapaNeiva3);
            neiva.Layers.Add(mapaNeiva4);
            neiva.Layers.Add(mapaNeiva5);
            neiva.Layers.Add(mapaNeiva6);
            neiva.Layers.Add(mapaNeiva7);
            neiva.Layers.Add(mapaNeiva8);
            neiva.Layers.Add(mapaNeiva9);
            neiva.Layers.Add(mapaNeiva10);
            neiva.Layers.Add(mapaNeiva11);
            neiva.Layers.Add(mapaNeiva12);
            neiva.Layers.Add(mapaNeiva13);
            neiva.Layers.Add(mapaNeiva14);

            winformsMap1.Overlays.Add(cuerposAcuaticos);
            winformsMap1.Overlays.Add(vias);
            winformsMap1.Overlays.Add(neiva);

            winformsMap1.CurrentExtent = new RectangleShape(-139.2, 92.4, 120.9, -93.2);

            winformsMap1.Refresh();
        }

        private void Map_MouseMove(object sender, MouseEventArgs e)
        {
            //Displays the X and Y in screen coordinates.
            statusStrip1.Items["toolStripStatusLabelScreen"].Text = "X:" + e.X + " Y:" + e.Y;

            //Gets the PointShape in world coordinates from screen coordinates.
            PointShape pointShape = ExtentHelper.ToWorldCoordinate(winformsMap1.CurrentExtent, new ScreenPointF(e.X, e.Y), winformsMap1.Width, winformsMap1.Height);

            //Displays world coordinates.
            statusStrip1.Items["toolStripStatusLabelWorld"].Text = "(world) X:" + Math.Round(pointShape.X, 4) + " Y:" + Math.Round(pointShape.Y, 4);
        }

      
       

    }
}
